/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : CityList.h                                               */
/*                                                                       */
/*       Date : February 15, 1997                                        */
/* Updated at : February 15, 1997                                        */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/*************************************************************************/

#ifndef _CITYLIST_H
#define _CITYLIST_H

#include <iostream.h>
#include <string.h>

#include <gVector.h>
#include "City.h"

class CityList {

  public :

     CityList() 
     { 
	mycities = new gVector<City>();

     }; // end of CONSTRUCTOR 

     ~CityList() { delete mycities; };

     City* getCity(int cityIndex) 
     {
        return mycities->getElement(cityIndex);
     }

     getCityIndex(char* cityName) 
     { 
	City *ele;
	int i=0;
	int ret = -1;

	while(i<mycities->getSize() && ret==-1)
	{
	   ele = mycities->getElement(i);
	   if(ele!=NULL && strncmp(cityName,ele->getName(),30)==0) ret=i;
	   else i++;

	}// end of while

	if(ret==-1)
	{
	   ele = new City(cityName,i);
	   mycities->addElement(*ele);
	   ret = i;

	}// end of if

	return ret;
     };

     getNumberOfCities() { return mycities->getSize(); };

     void addCity(City ele) { mycities->addElement(ele); };

     //
     void nicePrint(ostream& os)  const
     {
	os << " Cities : { ";
	for(int i=0;i<mycities->getSize();i++)
	   os << *mycities->getElement(i) << " " ; 
	os << " } " << endl;

     };

     friend ostream& operator<<(ostream& os, const CityList& RHS)
     { 
        RHS.nicePrint(os);
        return os;
     };

  private :

     gVector<City> *mycities;

}; // end of Class CityList

#endif 
